import * as _codemirror_state from '@codemirror/state';
import { ViewPlugin, DecorationSet, EditorView, ViewUpdate } from '@codemirror/view';

/**
 * Plugin to add style blockquotes.
 */
declare class BlockQuotePlugin {
    decorations: DecorationSet;
    constructor(view: EditorView);
    update(update: ViewUpdate): void;
    /**
     *
     * @param view - The editor view
     * @returns The blockquote decorations to add to the editor
     */
    private styleBlockquote;
}
/**
 * Ixora blockquote plugin.
 *
 * This plugin allows to:
 * - Decorate blockquote marks in the editor
 * - Add default styling to blockquote marks
 */
declare function blockquote(): (ViewPlugin<BlockQuotePlugin> | readonly _codemirror_state.Extension[])[];

export { blockquote };
