import { ViewPlugin, DecorationSet, EditorView, ViewUpdate } from '@codemirror/view';

/**
 * These types contain markers as child elements that can be hidden.
 */
declare const typesWithMarks: string[];
/**
 * The elements which are used as marks.
 */
declare const markTypes: string[];
/**
 * Plugin to hide marks when the they are not in the editor selection.
 */
declare class HideMarkPlugin {
    decorations: DecorationSet;
    constructor(view: EditorView);
    update(update: ViewUpdate): void;
    compute(view: EditorView): DecorationSet;
}
/**
 * Ixora hide marks plugin.
 *
 * This plugin allows to:
 * - Hide marks when they are not in the editor selection.
 */
declare const hideMarks: () => ViewPlugin<HideMarkPlugin>[];

export { hideMarks, markTypes, typesWithMarks };
