import * as _codemirror_state from '@codemirror/state';
import { WidgetType, EditorView, ViewPlugin, DecorationSet, ViewUpdate } from '@codemirror/view';

/**
 * Ixora Links plugin.
 *
 * This plugin allows to:
 * - Add an interactive link icon to a URL which can navigate to the URL.
 */
declare const links: () => _codemirror_state.Extension[];
declare class GoToLinkWidget extends WidgetType {
    readonly link: string;
    constructor(link: string);
    toDOM(view: EditorView): HTMLElement;
}
declare const goToLinkPlugin: ViewPlugin<{
    decorations: DecorationSet;
    update(update: ViewUpdate): void;
}>;

export { GoToLinkWidget, goToLinkPlugin, links };
