import { StateField } from '@codemirror/state';

/**
 * A heading slug is a string that is used to identify/reference
 * a heading in the document. Heading slugs are URI-compatible and can be used
 * in permalinks as heading IDs.
 */
interface HeadingSlug {
    slug: string;
    pos: number;
}
/**
 * A plugin that stores the calculated slugs of the document headings in the
 * editor state. These can be useful when resolving links to headings inside
 * the document.
 */
declare const headingSlugField: StateField<HeadingSlug[]>;

export { HeadingSlug, headingSlugField };
